#NoEnv
SendMode Input
SetWorkingDir %A_ScriptDir%
SetDefaultMouseSpeed, 0
SetTitleMatchMode, 3        ;Exact window title match
ATITDWindow:="eGenesis Client ahk_class eGenesis Client"

;Offsets from bottom left corner
;
;Add wood -   +36, -25
;Add water -  +85, -25
;Vent low -   +131, -25
;Vent med -   +156, -25
;Vent high -  +181, -25

;TODO:
;recovery on error

OvenMaxWidth:=300
OvenMaxHeight:=400
OvenMinWidth:=170
OvenMinHeight:=200

DebugMode:=0
Ovens:=0

;Find game window(s)
While (WindowHandle == "" || WindowHandle == 0)
{
  WinWait, %ATITDWindow%
  WinGet, WindowHandle, List, eGenesis Client ahk_class eGenesis Client
  If (A_Index > 50)
  {
    MsgBox, Error detecting ATITD Window.
    return
  }
}
If (%WindowHandle% > 1)
{
  MsgBox, Multiple game windows found. Using only the first one.
}
WinGetPos, WinPosX, WinPosY, WindowWidth, WindowHeight, ahk_id %WindowHandle1%

;Here we sync to the window.
WinWaitActive, %ATITDWindow%
ImageSearch, FoundX, FoundY, 0, 0, WindowWidth, WindowHeight, *5 pyramid_small.png
If (ErrorLevel == 2)
{
  MsgBox, pyramid_small.png: Error opening file.
  return
}
Else If (ErrorLevel == 0)
{
  TopRightX:=FoundX+18
  TopRightY:=FoundY-31
}
Else If (ErrorLevel == 1)
{
  MsgBox, Could not sync to window. Make sure you have the small pyramid icon in upper right corner.
  return
}

ImageSearch, FoundX, FoundY, 0, 0, WindowWidth, WindowHeight, *60 skills_bottom.png
If (ErrorLevel == 2)
{
  MsgBox, skills_bottom.png: Error opening file.
  return
}
If (ErrorLevel == 1)
{
  MsgBox, Could not sync to window. Make sure your skills window is not minimized.
  return
}
If (ErrorLevel == 0)
{
  BottomLeftX:=FoundX - 4
  BottomLeftY:=FoundY + 9
}

BorderX:=WindowWidth - TopRightX - 1
BorderY:=WindowHeight - BottomLeftY - 1
GameWidth:=WindowWidth - 2*BorderX
GameHeight:=WindowHeight - TopRightY - BorderY
TopLeftX:=BorderX
TopLeftY:=TopRightY

;This finds all a/your charcoal oven/hearth
SearchStartX:=0
SearchStartY:=0
Loop
{
  FoundOven:=0
  FoundHearth:=0
  If (SearchStartY >= WindowHeight - 170)
  {
    break
  }
  ImageSearch, FoundX, FoundY, SearchStartX, SearchStartY, WindowWidth, WindowHeight - 170, *60 this_is.png
  If (ErrorLevel == 2)
  {
    MsgBox, this_is.png: Error opening file or invalid search parameters.
    return
  }
  If (ErrorLevel == 1)
  {
    break
  }
  If (ErrorLevel == 0)
  {
    ;We found a window. Let's see if it's either a Charcoal Oven or Charcoal Hearth

    If (DebugMode == 1)
    {
      FileAppend, Found a this_is window at: %FoundX%`, %FoundY%`n, debug.txt
    }
    ImageSearch, , , FoundX, FoundY, FoundX + 200, FoundY + 30, *60 charcoal_oven.png
    If (ErrorLevel == 2)
    {
      MsgBox, charcoal_oven.png: Error opening file or invalid search parameters.
      return
    }
    If (ErrorLevel == 0)
    {
      FoundOven:=1
    }
    If (ErrorLevel == 1)
    {
      ImageSearch, , , FoundX, FoundY, FoundX + 200, FoundY + 30, *60 charcoal_hearth.png
      If (ErrorLevel == 2)
      {
        MsgBox, charcoal_hearth.png: Error opening file or invalid search parameters.
        return
      }
      If (ErrorLevel == 0)
      {
        FoundHearth:=1
      }
      ;If the building is neither an oven nor a hearth
      If (ErrorLevel == 1)
      {
        SearchStartY:=FoundY + 1
      }
    }

    If (FoundOven == 1 || FoundHearth == 1)
    {
      Ovens++
      OvenX%Ovens%:=FoundX
      OvenY%Ovens%:=FoundY

      If (FoundOven == 1)
      {
        OvenIsAHearth%Ovens%:=0
      }
      Else If (FoundHearth == 1)
      {
        OvenIsAHearth%Ovens%:=1
      }
      SearchStartY:=FoundY + 1

      ;Here we find any ovens hidden on the same line
      ;Have to know the vertical dimension of the png file for this one
    }

    SearchStartX2:=FoundX + 1
    SearchStartY2:=FoundY
    Loop
    {
      FoundOven:=0
      FoundHearth:=0
      If (SearchStartX2 > WindowWidth)
      {
        break
      }

      If (DebugMode == 1)
      {
        FileAppend, Let's see if there's any windows behind it...`nImagesearch`, `, `, %SearchStartX2%`, %SearchStartY2%`, %WindowWidth%`, %SearchStartY2%+23`, *60 this_is.png`n, debug.txt
      }

      ImageSearch, FoundX, FoundY, SearchStartX2, SearchStartY2, WindowWidth, SearchStartY2+22, *60 this_is.png
      If (ErrorLevel == 2)
      {
        MsgBox, this_is.png: Error opening file or invalid search parameters.
        return
      }
      If (ErrorLevel == 1)
      {
        break
      }
      If (ErrorLevel == 0)
      {
        ;We found a window. Let's see if it's either a Charcoal Oven or Charcoal Hearth

        ImageSearch, , , FoundX, FoundY, FoundX + 200, FoundY + 30, *60 charcoal_oven.png
        If (ErrorLevel == 2)
        {
          MsgBox, charcoal_oven.png: Error opening file or invalid search parameters.
          return
        }
        If (ErrorLevel == 0)
        {
          FoundOven:=1
        }
        If (ErrorLevel == 1)
        {
          ImageSearch, , , FoundX, FoundY, FoundX + 200, FoundY + 30, *60 charcoal_hearth.png
          If (ErrorLevel == 2)
          {
            MsgBox, charcoal_hearth.png: Error opening file or invalid search parameters.
            return
          }
          If (ErrorLevel == 0)
          {
            FoundHearth:=1
          }
          If (ErrorLevel == 1)
          {
            SearchStartX2:=FoundX+1
          }
        }

        If (FoundOven == 1 || FoundHearth == 1)
        {
          Ovens++
          OvenX%Ovens%:=FoundX
          OvenY%Ovens%:=FoundY

          If (DebugMode == 1)
          {
            FileAppend, FoundAnotherOven: Oven%Ovens%: %FoundX%`, %FoundY%`n, debug.txt
          }

          If (FoundOven == 1)
          {
            OvenIsAHearth%Ovens%:=0
          }
          Else If (FoundHearth == 1)
          {
            OvenIsAHearth%Ovens%:=1
          }
          SearchStartX2:=FoundX+1
        }
      }
    }
  }
}

If (DebugMode == 1)
{
  Loop, %Ovens%
  {
    ToolTip, %A_Index%, OvenX%A_Index%, OvenY%A_Index%, A_Index
    Temp1:=OvenX%A_Index%
    Temp2:=OvenY%A_Index%
    FileAppend, Oven%A_Index%: %Temp1%`, %Temp2%`n, debug.txt 
  }
}

;At this point we found all the oven and hearth windows. Now let's find the lower left and lower right corners.
Loop, %Ovens%
{
  i:=A_Index
  ImageSearch, FoundX, FoundY, OvenX%i%, OvenY%i%, OvenX%i% + OvenMaxWidth, OvenY%i% + OvenMaxHeight, *60 lower_right.png
  If (ErrorLevel == 2)
  {
    MsgBox, lower_right.png: Error opening file or invalid search parameters.
    return
  }
  If (ErrorLevel == 1)
  {
    MsgBox, Could not find the lower right corner of oven %i%.
    return
  }
  If (ErrorLevel == 0)
  {
    OvenWidth%i%:=FoundX - OvenX%i% + 16
    OvenHeight%i%:=FoundY - OvenY%i% + 16
  }
}

;Now that we know the dimension of the windows, let's find the Begin buttons.
Loop, %Ovens%
{
  i:=A_Index
  ImageSearch, FoundX, FoundY, OvenX%i%, OvenY%i%, OvenX%i% + OvenWidth%i%, OvenY%i% + OvenHeight%i%, *70 begin.png
  If (ErrorLevel == 2)
  {
    MsgBox, begin.png: Error opening file or invalid search parameters.
    return
  }
  If (ErrorLevel == 1)
  {
    MsgBox, Could not find the Begin button for oven %i%.
    return
  }
  If (ErrorLevel == 0)
  {
    OvenBeginX%i%:=FoundX
    OvenBeginY%i%:=FoundY
  }
}

If (Ovens > 0)
{
  MsgBox, Found %Ovens% ovens and hearths. Hit Ctrl+Alt+Shift+`` (that's the tilde key) to begin.
}
else
{
  MsgBox, No ovens or hearths found!
  return
}

#IfWinActive, eGenesis Client ahk_class eGenesis Client

;Clicks the Begin buttons.
^+!`::
;Do some sanity checks first before starting.
If (Ovens == "" || Ovens <= 0)
{
  MsgBox, No ovens found. Aborting.
  return
}
Loop, %Ovens%
{
  i:=A_Index
  If (OvenX%i% == "" || OvenY%i% == "" || OvenBeginX%i% == "" || OvenBeginY%i% == "")
  {
    MsgBox, Error found with oven parameters.
    return
  }
}

Loop, %Ovens%
{
  i:=A_Index
  KeyWait, LButton
  KeyWait, RButton
  ClickInstant(OvenBeginX%i%, OvenBeginY%i%, 1)
}
return

;add wood
^a::
Loop, %Ovens%
{
  i:=A_Index
  KeyWait, LButton
  KeyWait, RButton
  ClickInstant(OvenX%i% + 36, OvenY%i% + OvenHeight%i% - 25, 1)
}
return

;adds water
^w::
Loop, %Ovens%
{
  i:=A_Index
  KeyWait, LButton
  KeyWait, RButton
  ClickInstant(OvenX%i% + 85, OvenY%i% + OvenHeight%i% - 25, 1)
}
return

;Sets vent to low
^1::
Loop, %Ovens%
{
  i:=A_Index
  KeyWait, LButton
  KeyWait, RButton
  ClickInstant(OvenX%i% + 131, OvenY%i% + OvenHeight%i% - 25, 1)
}
return

;Sets vent to medium
^2::
Loop, %Ovens%
{
  i:=A_Index
  KeyWait, LButton
  KeyWait, RButton
  ClickInstant(OvenX%i% + 156, OvenY%i% + OvenHeight%i% - 25, 1)
}
return

^3::
Loop, %Ovens%
{
  i:=A_Index
  KeyWait, LButton
  KeyWait, RButton
  ClickInstant(OvenX%i% + 181, OvenY%i% + OvenHeight%i% - 25, 1)
}
return

^+#a::
MouseGetPos, MouseX, MouseY
OpenOvens++
OpenOvenX%OpenOvens%:=MouseX
OpenOvenY%OpenOvens%:=MouseY
return

^+!#o::
OpenWindows(226, 280, WindowWidth, WindowHeight)
return

OpenWindows(IntervalX, IntervalY, WindowWidth, WindowHeight, XStart=20, YStart=50, WaitTime=100)
{
  global
  local WindowsX:=(WindowWidth - XStart - 20)//IntervalX
  local WindowsY:=OpenOvens//WindowsX + 1

  Counter:=0
  Loop, %WindowsY%
  {
    i:=A_Index
    Loop, %WindowsX%
    {
      j:=A_Index
      Counter:=(i-1)*WindowsX + j
      If (Counter > OpenOvens)
        break
      MouseMove, XStart + (j-1)*IntervalX, YStart + (i-1)*IntervalY + IntervalY//2
      Sleep, WaitTime
      ClickInstant(OpenOvenX%Counter%, OpenOvenY%Counter%)
    }
    If (Counter > OpenOvens)
      break
  }
}

;Sets a very minimalistic style for the window: No title bar or border
;Also makes the window take up the whole screen
;TODO: Support for multiple monitors
^!+F12::
WinSet, Style, 0x16000000, %ATITDWindow%
WinMove, %ATITDWindow%, , 0, 0, A_ScreenWidth, A_ScreenHeight
return

ClickInstant(X, Y, Button=2, WaitForMouse=0, TurnOnCritical=0)
{
  global WindowHandle1
  global TopLeftX
  global TopLeftY

  ;Button 1 is left click, 2 is right click
  If (Button == 1)
  {
    wParam1:=0x0201
    wParam2:=0x0202
  }
  Else If (Button == 2)
  {
    wParam1:=0x0204
    wParam2:=0x0205
  }

  If (WaitForMouse == 1)
  {
    KeyWait, LButton
    KeyWait, RButton
  }

  If (TurnOnCritical == 1)
  {
    Critical, On
  }

  PostMessage, wParam1, 0, X - TopLeftX + (Y - TopLeftY<<16), , eGenesis Client ahk_class eGenesis Client
  PostMessage, wParam2, 0, X - TopLeftX + (Y - TopLeftY<<16), , eGenesis Client ahk_class eGenesis Client

  If (TurnOnCritical == 1)
  {
    Critical, Off
  }
}

;Script macros here
#IfWinActive

^+!r::Reload
^+!e::Edit
